/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: AVRProgrammer.hpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 1163 $
 * t		: $Date: 2006N82 15:38:16 +0200 $
 * XV	: $Author: ohlia $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: AVR޲pW݊ɑ΂gg݂܂ޒ۸׽łBׯA
 *			  EEPROMA{ޯĂƑSĂ˭ ޯĂ̓ǂݏOSCCALǂݍ݂Ǝ
 *			  [޲ēǂݍ݂x܂B
 *
****************************************************************************/
#ifndef AVRPROGRAMMER_HPP
#define AVRPROGRAMMER_HPP

using namespace std;

#include "ErrorMsg.hpp"
#include "HEXParser.hpp"
#include "CommChannel.hpp"

class AVRProgrammer
{
	protected:
		long pagesize;							// ׯ ߰ޗe
		CommChannel * comm;

	public:
		/* ݽ׸ */
		AVRProgrammer( CommChannel * _comm );

		/* ޽׸ */
		~AVRProgrammer();

		/* ÓI */
		static string readProgrammerID( CommChannel * _comm );	// 7IDǂݍD.

		/* ҿ */
		void setPagesize( long _pagesize ) { pagesize = _pagesize; }

		virtual bool enterProgrammingMode() = 0;
		virtual bool leaveProgrammingMode() = 0;

		virtual bool chipErase() = 0;
		virtual unsigned char RC_Calibrate() = 0;

		virtual bool readOSCCAL( long pos, long * value ) = 0;
		virtual bool readSignature( long * sig0, long * sig1, long * sig2 ) = 0;
		virtual bool checkSignature( long sig0, long sig1, long sig2 ) = 0;

		virtual bool writeFlashByte( long address, long value ) = 0;
		virtual bool writeEEPROMByte( long address, long value ) = 0;

		virtual bool writeFlash( HEXFile * data ) = 0;
		virtual bool readFlash( HEXFile * data ) = 0;

		virtual bool writeEEPROM( HEXFile * data ) = 0;
		virtual bool readEEPROM( HEXFile * data ) = 0;

		virtual bool writeLockBits( long bits ) = 0;
		virtual bool readLockBits( long * bits ) = 0;

		virtual bool writeFuseBits( long bits ) = 0;
		virtual bool readFuseBits( long * bits ) = 0;
		virtual bool writeExtendedFuseBits( long bits ) = 0;
		virtual bool readExtendedFuseBits( long * bits ) = 0;

		virtual bool programmerSoftwareVersion( long * major, long * minor ) = 0;
		virtual bool programmerHardwareVersion( long * major, long * minor ) = 0;
};

#endif
